unit ayashellu;

//////////////////////////////////////////////////////////////////////////////
//
// Shell Utilities for Unicode
//
// original source from 'DRPCOMEX.PAS' by
//     ContextMenuEx and DropSourceEx component version 2.05
//     (c)1997-1998 by HISHIAMAZON All Rights Reserved.
// original source from TContextMenu(@NIFTY FDELPHI-MES16/1166)
//     by Atelier Macchan
//
// modified compo for Unicode Rev. by
//     (c)2004-2009 by Ayakawa,Marinosuke All Rights Reserved.
//        http://homepage1.nifty.com/Ayakawa/
//
// Copyright (C) 2004-2009 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @A]ځEzzƂ̓A[JCu̍\͕ςȂłB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́A؂̐ӔCE`
//   𕉂܂BgpɂȂ̐ӔČɁǍʂ𕉂Ă
//   Bꂪ[Ȃ̂ł΁ApfOĂB
//
// Unicode
//
// rev  0.00
// date 2004/03/01
// auth Ayakawa,Marinosuke
// memo qVA}]̃\[XA̃[`ʃjbg
//      ړUnicodeΉ
//      FDelphi MES16/1166̋L肢WbNQ
//      ̑AShell֘Ây葱ȂǁB
//
// rev  0.01
// date 2004/03/02
// auth Ayakawa,Marinosuke
// memo ֐̕ύXA̒`葱ayashell.pasɈڍs
//
// rev  0.02
// date 2004/03/05
// auth Ayakawa,Marinosuke
// memo AyaShGetDataEx'C:\'ȂǂRootDrivẽf[^쐬łȂ~X
//      C
//      PIDListFromPathWayashell.pasɈړ
//
// rev  0.03
// date 2004/03/16-2004/03/17
// auth fT
// memo SHFileOperation̒Pȃbp[ǉ
//      AyaShGetDataExWŃT[o[ELT|[g
//
// rev  0.04
// date 2005/05/22
// auth fT
// memo TntR|ver2.1.12̕ύXɑΉ
//
// rev  0.05
// date 2008/10/25
// auth fT
// memo Delphi 2009Ή,jbgayashelluɕύX
//      ayashell.pas炢̊֐ڐA
//
// rev  0.06
// date 2008/11/17
// auth fT
// memo GetLnk2OrgUC
//
// rev  0.07
// date 2009/02/08
// auth fT
// memo SHGetPathFromIDListExǉ
//
// rev  0.08
// date 2009/07/06
// auth fT
// memo AyaShGetDataExUT[o[ELŎ|삵Ȃ~XC
//      AyaShGetDataExUG[Ñ[NC
//
//////////////////////////////////////////////////////////////////////////////

interface

uses
  windows, Sysutils, classes, ShlObj, ActiveX, ComObj, shellapi, ayafutilu;

type
  // arcdropsdropcomeexwȂǂŎgp܂
  TPItemIDListArray = array of PItemIDList;

// .lnk{̂̃pX擾
// .lnkłȂȂ󕶎Ԃ
function GetLnk2OrgU(const lnkname:string):string;

// .lnkȂΖ{̂̃pXԂBłȂȂ炻̂܂ܕԂ
function ConvLnk2OrgU(const lnkname:string):string;

// .lnk쐬
// ShortcutPath : link̃t@C
// Description  : Rg
// WorkDir      : ƃfBNg
// Path         : .lnkt@C쐬fBNgB󕶎w肷
//                CSIDLŎw肵tH_ɍ쐬
// Name         : .lnkt@C̖OB󕶎w肷ShortcutPathŎw
//                肵t@C̊gq.lnkɕςɂȂ
// CSIDL        : ȃtH_ɍ쐬ꍇw肷
function MakeShortcutU(ShortCutPath,Description,WorkDir,Path,Name:string; CSIDL:integer):boolean;

// ȃtH_̈ʒu擾ĕԂ
function GetSpecialDirU(CSIDL:integer):string;

// t@CItemIDList𐶐
function PIDListFromPathU(Path:String):PItemIDList;

// lpifqlpsflpi𐶐
// lpifq́utpXvItemIDList, lpsf̓tH_[A
// lpilpifqlpsf猩u΁vItemIDList
//   - qVA}]ShGetData܂܂łB
function AyaShGetData(const lpifq: PItemIDList; var lpsf: IShellFolder; var lpi: PItemIDList): BOOL;

// Fileslpsfarlpi𐶐
// Files͓fBNgɂ̂̂ݗLł
// 擪̃f[^[ghCuELET[ȍꍇAȊÕf[^͈܂
function AyaShGetDataExU(var lpsf:IShellFolder; var arlpi:TPItemIDListArray; Files:TStringList):BOOL;

// w肳ꂽPItemIDListArray̒gj܂
procedure AyaShDisposePItemIDList(var arlpi:TPItemIDListArray; ppmem:IMAlloc);

// tH[}bg_CAO\
// hwnd    : _CAO̐eWindow
// drive   : A=0,B=1,...
// fmtID   : must use SHFMT_ID_DEFAULT
// options : bitfield
//           SHFMT_OPT_FULL    = QuickFormatNAĂ
//           SHFMT_OPT_SYSONLY = _CAŐNp̃`FbNftHgƂĐݒ
const
  SHFMT_ID_DEFAULT  = $FFFF;
  SHFMT_OPT_FULL    = 1;
  SHFMT_OPT_SYSONLY = 2;

function SHFormatDrive( hwnd: THandle;
                        drive: Integer;
                        fmtID: Integer;
                        options: Integer ): Integer; stdcall;

// ShelloR̃t@C
function SHFileCopyU(wnd:HWND; FromList,ToDir:string; Undo:boolean):integer; overload;
function SHFileCopyU(wnd:HWND; FromList:TStringList; ToDir:string; Undo:boolean):integer; overload;
function SHFileMoveU(wnd:HWND; FromList,ToDir:string; Undo:boolean):integer; overload;
function SHFileMoveU(wnd:HWND; FromList:TStringList; ToDir:string; Undo:boolean):integer; overload;
function SHFileRenameU(wnd:HWND; List:string; Undo:boolean):integer; overload;
function SHFileRenameU(wnd:HWND; List:TStringList; Undo:boolean):integer; overload;
function SHFileDeleteU(wnd:HWND; List:string; Undo:boolean):integer; overload;
function SHFileDeleteU(wnd:HWND; List:TStringList; Undo:boolean):integer; overload;

// VISTAȍ~Ŏgp\
type
  GPFIDL_FLAGS = integer;
const
  GPFIDL_DEFAULT    = $0000; // normal Win32 file name, servers and drive roots included
  GPFIDL_ALTNAME    = $0001; // short file name
  GPFIDL_UNCPRINTER = $0002;
function SHGetPathFromIDListEx(const lpifq: PItemIDList; pszPath:PWideChar; cchPath:DWORD; Ops:GPFIDL_FLAGS):BOOL; stdcall;

implementation

function GetSpecialDirU(CSIDL:integer):string;
var
  ppmem: IMalloc;
  lpi: PItemIDList;
  Directory : array[0..MAX_PATH] of WideChar;
begin
  result:='';
  IF FAILED(ShGetMalloc(ppmem)) THEN exit;
  IF FAILED(SHGetSpecialFolderLocation(0, CSIDL, lpi)) THEN exit;
  IF SHGetPathFromIDListW(lpi, Directory) THEN result:=Directory;
  IF Assigned(lpi) THEN ppmem.Free(lpi);
end;

function GetLnk2OrgU(const lnkname:string): string;
var
  slw  :IShellLink;
  pf   :IPersistFile;
  work : string;
  path : array[0..MAX_PATH] of WideChar;
  dat         : TWin32FindData;
begin
  result:='';
  work:=lnkname;
  slw:=CreateComObject(CLSID_ShellLink) as IShellLink;
  pf:=slw As IPersistFile;
  IF Succeeded(pf.Load(PWideChar(work),STGM_READ)) THEN BEGIN
    slw.Resolve(0,SLR_ANY_MATCH);
    FillChar(path[0], sizeof(path),0);
    slw.GetPath(@path[0], MAX_PATH, dat, SLGP_UNCPRIORITY);
    result:=path;
  END;
end;

function ConvLnk2OrgU(const lnkname:string):string;
begin
  IF AnsiUpperCase(ExtractFileExt(lnkname))='.LNK' THEN BEGIN
    result:=GetLnk2OrgU(lnkname);
    IF result='' THEN result:=lnkname;
  END ELSE
    result:=lnkname;
end;

function MakeShortCutU(ShortCutPath,Description,WorkDir,path,Name:String; CSIDL:integer):boolean;
var
  ppmem: IMalloc;
  Directory : array[0..MAX_PATH] of WideChar;
  UnknownObject: IUnknown;
  psl: IShellLinkW;
  ppf: IPersistFile;
  lpi: PItemIDList;
  szDirectory,wFileName : string;
begin
  result:=FALSE;
  UnknownObject:= CreateComObject(CLSID_ShellLink);
  if not Assigned(UnknownObject) then exit;
  psl:= UnknownObject as IShellLinkW;
  ppf:= UnknownObject as IPersistFile;
  if not Assigned(psl) or not Assigned(ppf) then exit;
  if FAILED(ShGetMalloc(ppmem)) then exit;
  FillChar(Directory[0],sizeof(Directory),0);
  IF path='' THEN BEGIN
    IF FAILED(SHGetSpecialFolderLocation(0, CSIDL, lpi)) then exit;
    IF not SHGetPathFromIDListW(lpi, Directory) then begin
      if Assigned(lpi) then ppmem.Free(lpi);
      exit;
    end;
  END ELSE
    StrCopy(Directory,PWideChar(ExpandFilename(Path)));
  IF StrLen(Directory)=3 THEN StrLCopy(Directory,Directory,2);  // for X:\
  with psl do
  begin
    SetPath(PWideChar(ShortcutPath));
    SetWorkingDirectory(PWideChar(WorkDir));
    SetDescription(PWideChar(Description));
  end;
  szDirectory:=Directory;
  IF Name='' THEN
    Name:=ChangeFileExt(ExtractFileName(ShortcutPath),'');
  IF (path='') AND (CSIDL=CSIDL_DESKTOPDIRECTORY) THEN
    wFileName:= szDirectory+YenW+
                Name+
                string('ւ̼Ķ.lnk')
  ELSE
    wFileName:= szDirectory+YenW+
                Name+
                string('.lnk');
  result:=SUCCEEDED(ppf.Save(PWideChar(WFileName), False));
  if Assigned(lpi) then ppmem.Free(lpi);
  // ExplolerɕύXʒm
  IF result THEN
    SHChangeNotify(SHCNE_UPDATEITEM, SHCNF_PATH, PWideChar(WFilename), nil);
end;

function PIDListFromPathU(Path:String):PItemIDList;
var
  Eatan,Attrs : UINT;
  pfldr : IShellFolder;
  pidl : PItemIDList;
begin
  result:=nil;
  IF ( SUCCEEDED( SHGetDesktopFolder( pfldr ) ) ) THEN BEGIN
    IF ( SUCCEEDED(pfldr.ParseDisplayName(0,nil,PWideChar(Path),Eatan, pidl, Attrs ) ) ) THEN BEGIN
      result:=pidl;
    END;
  END;
end;

function Next(pidl: PItemIdList): PItemIDList;
var
  lpMem: PChar; // do not convert PChar to PWideChar !!
begin
  lpMem:= PChar(pidl);
  inc(lpMem,integer(pidl^.mkid.cb));
  Result:= PItemIDList(lpmem);
end;

function GetItemCount(pidl: PItemIDList): UINT;
begin
  Result:= 0;
  if Assigned(pidl) then begin
    while pidl^.mkid.cb <> 0 do begin
      inc(Result);
      pidl:= Next(pidl);
    end;
  end;
end;

function GetSize(pidl: PItemIDList): UINT;
begin
  Result:= 0;
  if Assigned(pidl) then begin
    inc(Result, sizeof(pidl^.mkid.cb));
    while pidl^.mkid.cb <> 0 do begin
      inc(Result, integer(pidl^.mkid.cb));
      pidl:= Next(pidl);
    end;
  end;
end;

function pidlCreate(cbSize: UINT): PItemIDList;
var
  ppmem: IMalloc;
begin
  Result:= nil;
  if FAILED(SHGetMalloc(ppmem)) then exit;
  Result:= PItemIDList(ppmem.Alloc(cbSize));
  if Result <> nil then
    FillChar(Result^,cbSize,0);
end;

function ConcatPidls(pidl1, pidl2: PItemIDList): PItemIDList;
type
  BytePtr = ^Byte;
var
  cb1, cb2: UINT;
begin
  if pidl1 <> nil then
    cb1:= GetSize(pidl1)-SizeOf(pidl1^.mkid.cb) else
    cb1:= 0;
  cb2:= GetSize(pidl2);
  Result:= pidlCreate(cb1 + cb2);
  if Assigned(Result) then begin
    if pidl1<>nil then
      Move(pidl1^, Result^, cb1);
    Move(pidl2^, BytePtr(UINT(Result)+cb1)^, cb2);
  end;
end;

function CopyItemID(pidl: PItemIDList): PItemIDList;
var
  cb: UINT;
begin
  Result:= nil;
  if Assigned(pidl) then begin
    cb:= (pidl^.mkid.cb+sizeof(pidl^.mkid.cb));
    Result:= pidlCreate(cb);
    if Assigned(Result) then
      Move(pidl^, Result^, pidl^.mkid.cb);
  end;
end;

function GetNextItemID(pidl: PItemIDList):PItemIDList;
type
  BytePtr = ^Byte;
var
  cb: integer;
begin
  Result:= nil;
  cb:= Integer(pidl^.mkid.cb);
  if cb <> 0 then begin
    inc(BytePtr(pidl),cb);
    if pidl^.mkid.cb <> 0 then
      Result:= pidl;
  end;
end;

function GetPidlfqFromPath(const Path: string): PItemIDList;
var
  swPath: WideString;
  lpsfDeskTop: IShellFolder;
  lpifq: PItemIDList;
  ulEaten, ulAttribs: ULONG;
begin
  Result:= nil;
  if FAILED(SHGetDesktopFolder(lpsfDeskTop)) then exit;
  swPath:= Path;
  if SUCCEEDED(lpsfDeskTop.ParseDisplayName(0, nil, PWideChar(swPath), ulEaten, lpifq, ulAttribs)) then
    Result:= lpifq;
end;

function GetLastlpi(lpifq: PItemIdList): PItemIDList;
var
  pidlTemp: PItemIdList;
begin
  Result:= nil;
  if not Assigned(lpifq) then exit;
  pidlTemp:= lpifq;
  while pidlTemp <> nil do begin
    pidlTemp:= GetNextItemID(lpifq);
    if Assigned(pidlTemp) then
      lpifq:= pidlTemp;
  end;
  Result:= ConcatPidls(nil, lpifq);
end;

function GetlpiFromPath(const Path: string; var lpi: PItemIDList): BOOL;
var
  ppmem: IMalloc;
  lpifq: PItemIDList;
begin
  Result:= FALSE;
  if FAILED(ShGetMalloc(ppmem))then exit;
  lpifq:= GetPidlfqFromPath(Path);
  if Assigned(lpifq) then begin
    lpi:= GetLastlpi(lpifq);
    Result:= Assigned(lpi);
    ppmem.free(lpifq);
  end;
end;

function AyaShGetData(const lpifq: PItemIDList; var lpsf: IShellFolder; var lpi: PItemIDList): BOOL;
var
  ppmem: IMalloc;
  lpsfsub, lpsfdesktop: IShellFolder;
  pidlCopy, pidl: PItemIDList;
  i, ItemCount: UINT;
begin
  Result:= FALSE;
  if not Assigned(lpifq) or FAILED(ShGetMalloc(ppmem)) or FAILED(SHGetDesktopFolder(lpsfDeskTop)) then exit;
  ItemCount:= GetItemCount(lpifq);
  if ItemCount < 2 then exit;
  pidl:= lpifq;
  for i:= 1 to ItemCount-1 do begin
    pidlCopy:= CopyItemID(pidl);
    if FAILED(lpsfDeskTop.BindToObject(pidlCopy, nil, IID_IShellFolder, Pointer(lpsfsub))) then begin
      ppmem.free(pidlCopy);
      exit;
    end;
    lpsfdesktop:= lpsfsub;
    ppmem.free(pidlCopy);
    pidl:= GetNextItemID(pidl);
  end;
  lpsf:= lpsfDeskTop;
  lpi:= CopyItemID(pidl);
  Result:= Assigned(lpsf) and Assigned(lpi);
end;

function AyaShGetDataExU(var lpsf:IShellFolder; var arlpi:TPItemIDListArray; Files:TStringList):BOOL;
var
  i: integer;
  sfDesktop : IShellFolder;
  WFileName : string;
  Count,Attr : ULONG;
  ParentPidl : PItemIDList;
  ppmem : IMalloc;
begin
  Result:=false; lpsf:=nil; ParentPidl:=nil;
  IF FAILED(SHGetDesktopFolder(sfDesktop)) THEN Exit;
  if FAILED(ShGetMalloc(ppmem)) then exit;
  //
  SetLength(arlpi,Files.Count);
  for i := 0 to Files.Count - 1 do arlpi[i]:=nil;
  //
  try
    IF Files=nil THEN BEGIN
      // Files=nil -> Desktop
      SetLength(arlpi, 1);
      IF FAILED(SHGetSpecialFolderLocation(0, CSIDL_DRIVES, arlpi[0])) THEN Exit;
      lpsf:=sfDesktop;
    END ELSE IF IsRootDriveU(Files.Strings[0]) THEN BEGIN
      // ŏhCûƂ
      SetLength(arlpi, 1);
      IF FAILED(SHGetSpecialFolderLocation(0, CSIDL_DRIVES, ParentPidl)) THEN Exit;
      IF FAILED(sfDesktop.BindToObject(ParentPidl, nil, IID_IShellFolder,
                                       Pointer(lpsf))) THEN Exit;
      IF FAILED(lpsf.ParseDisplayName(0, nil,
                  PWideChar(Files.Strings[0]), Count, arlpi[0], Attr)) THEN Exit;
    END ELSE IF IsUNCServerU(Files[0]) THEN BEGIN
      // T[o[̏ꍇ
      SetLength(arlpi,1);
      if FAILED(SHGetSpecialFolderLocation(0, CSIDL_NETWORK, ParentPidl)) then exit;
      if FAILED(sfDesktop.BindToObject(ParentPidl, nil, IID_IShellFolder,
                                       Pointer(lpsf))) THEN Exit;
      IF FAILED(lpsf.ParseDisplayName(0, nil,
                  PWideChar(Files.Strings[0]), Count, arlpi[0], Attr)) THEN Exit;
    END ELSE IF IsUNCShareNameU(Files[0]) THEN BEGIN
      // L̏ꍇ
      WFileName := ExtractFileDir(Files[0]);
      IF FAILED(sfDesktop.ParseDisplayName(0, nil,
                      PWideChar(WFileName), Count, ParentPidl, Attr)) THEN Exit;
      IF FAILED(sfDesktop.BindToObject(ParentPidl, nil, IID_IShellFolder,
                                       Pointer(lpsf))) THEN Exit;
      FOR i := 0 TO Files.Count - 1 DO BEGIN
        if Win32MajorVersion>=6 then begin
          // VISTA or Later
          WFileName := ExtractFilename(Files.Strings[i]);
          IF FAILED(lpsf.ParseDisplayName(0, nil,PWideChar(WFileName),
                                          Count, arlpi[i], Attr)) THEN Exit;
        end else begin
          // 2000/XP
          if not GetlpiFromPath(Files.strings[i],arlpi[i]) then exit;
        end;
      END;
    END ELSE BEGIN
      // ̑̏ꍇ
      WFileName := ExtractFileDir(Files.Strings[0]);
      IF FAILED(sfDesktop.ParseDisplayName(0, nil,
                      PWideChar(WFileName), Count, ParentPidl, Attr)) THEN Exit;
      IF FAILED(sfDesktop.BindToObject(ParentPidl, nil, IID_IShellFolder,
                                       Pointer(lpsf))) THEN Exit;
      FOR i := 0 TO Files.Count - 1 DO BEGIN
        WFileName := ExtractFilename(Files.Strings[i]);
        IF FAILED(lpsf.ParseDisplayName(0, nil,
                      PWideChar(WFileName), Count, arlpi[i], Attr)) THEN Exit;
      END;
    END;
    result:=TRUE;
  finally
    if ParentPidl<>nil then ppmem.Free(ParentPidl);
    if not result then AyaShDisposePItemIDList(arlpi,ppmem);
  end;
end;

procedure AyaShDisposePItemIDList(var arlpi:TPItemIDListArray; ppmem:IMalloc);
var
  i,cnt : integer;
begin
  cnt:=High(arlpi);
  FOR i:=0 TO Cnt DO ppmem.Free(arlpi[i]);
end;


// ShelloR̃t@C
function SHFileOpU(wnd:HWND; Op:UINT; List:TStringList; ToDir:string; Undo:boolean):integer;
const
  sep : widechar = #0;
var
  shfo : TSHFileOpStructW;
  workfrom,workto : string;
  i : integer;
begin
  result:=-1;
  IF List.Count=0 THEN Exit;
  //
  workfrom:='';
  FOR i:=0 TO List.Count-1 DO
    workfrom:=workfrom+List.Strings[i]+sep;
  workfrom:=workfrom+sep;
  IF ToDir='' THEN workto:='' ELSE workto:=ToDir+sep+sep;
  //
  WITH shfo DO BEGIN
    wnd:=wnd;
    wFunc:=Op;
    pFrom:=PWideChar(workfrom);
    IF workto='' THEN pTo:=nil ELSE pTo:=PWideChar(workto);
    IF undo THEN fFlags:=FOF_ALLOWUNDO ELSE fFlags:=0;
    IF (Op=FO_COPY) OR (Op=FO_MOVE) OR (Op=FO_RENAME) THEN
      fFlags:=fFlags OR FOF_RENAMEONCOLLISION;
    fAnyOperationsAborted:=true;
    hNameMappings:=nil;
    lpszProgressTitle:=nil;
  END;
  try
    result:=SHFileOperationW(shfo);
  finally
    workfrom:=''; workto:='';
  end;
end;

function SHFileCopyU(wnd:HWND; FromList,ToDir:string; Undo:boolean):integer;
var
  l : TStringList;
begin
  l:=TStringList.Create;
  try
    l.Text:=FromList;
    result:=SHFileOpU(wnd,FO_COPY,l,ToDir,Undo);
  finally
    l.free;
  end;
end;

function SHFileCopyU(wnd:HWND; FromList:TStringList; ToDir:string; Undo:boolean):integer;
begin
  result:=SHFileOpU(wnd,FO_COPY,FromList,ToDir,Undo);
end;

function SHFileMoveU(wnd:HWND; FromList,ToDir:string; Undo:boolean):integer;
var
 l : TStringList;
begin
  l:=TStringList.Create;
  try
    l.Text:=FromList;
    result:=SHFileOpU(wnd,FO_MOVE,l,ToDir,Undo);
  finally
    l.free;
  end;
end;

function SHFileMoveU(wnd:HWND; FromList:TStringList; ToDir:string; Undo:boolean):integer;
begin
  result:=SHFileOpU(wnd,FO_MOVE,FromList,ToDir,Undo);
end;

function SHFileRenameU(wnd:HWND; List:string; Undo:boolean):integer;
var
 l : TStringList;
begin
  l:=TStringList.Create;
  try
    l.Text:=List;
    result:=SHFileOpU(wnd,FO_RENAME,l,'',Undo);
  finally
    l.free;
  end;
end;

function SHFileRenameU(wnd:HWND; List:TStringList; Undo:boolean):integer;
begin
  result:=SHFileOpU(wnd,FO_RENAME,list,'',Undo);
end;

function SHFileDeleteU(wnd:HWND; List:string; Undo:boolean):integer;
var
 l : TStringList;
begin
  l:=TStringList.Create;
  try
    l.Text:=List;
    result:=SHFileOpU(wnd,FO_DELETE,l,'',Undo);
  finally
    l.free;
  end;
end;

function SHFileDeleteU(wnd:HWND; List:TStringList; Undo:boolean):integer;
begin
  result:=SHFileOpU(wnd,FO_DELETE,list,'',Undo);
end;

function SHFormatDrive( hwnd: THandle;
                        drive: Integer;
                        fmtID: Integer;
                        options: Integer ): Integer; stdcall;
  external 'Shell32.DLL' name 'SHFormatDrive';


// VISTAȍ~
var
  HShlObj : THandle;
  _SHGetPathFromIDListEx:function (const lpifq: PItemIDList; pszPath:PWideChar; cchPath:DWORD; Ops:GPFIDL_FLAGS):BOOL; stdcall;

function SHGetPathFromIDListEx(const lpifq: PItemIDList; pszPath:PWideChar; cchPath:DWORD; Ops:GPFIDL_FLAGS):BOOL;
begin
  if @_SHGetPathFromIDListEx=nil then begin
    result:=false;
    SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
  end else
    result:=_SHGetPathFromIDListEx(lpifq,pszPath,cchPath,Ops);
end;

///////////////////////////////////////////////////////////////////////////
//
// 
//
///////////////////////////////////////////////////////////////////////////
procedure Init;
var
  sv : integer;
  p    : TFarProc;
begin
  CoInitialize(nil);
  _SHGetPathFromIDListEx:=nil;
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    HShlObj:=LoadLibrary('shlobj.dll');
    IF HShlObj<>0 THEN BEGIN
      p:=GetProcAddress(HShlObj,'SHGetPathFromIDListEx');
      IF p<>nil THEN @_SHGetPathFromIDListEx:=p;
    END;
  finally
    SetErrorMode(sv);
  end;
end;

///////////////////////////////////////////////////////////////////////////
//
// I
//
///////////////////////////////////////////////////////////////////////////
procedure Done;
begin
  if HShlObj<>0 then begin
    _SHGetPathFromIDListEx:=nil;
    FreeLibrary(HShlObj);
    HShlObj:=0;
  end;
  CoUninitialize;
end;


initialization
  Init;

finalization
  Done;

end.
