unit ayafutilu;

{$WARN SYMBOL_PLATFORM OFF}  // t@Čx؂

///////////////////////////////////////////////////////////////////////
//
// Delphi2009pUnicodeΉ̎Õt@C[eBeBQ
//
// Copyright (C) 2004-2009 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @A]ځEzzƂ̓A[JCu̍\͕ςȂłB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́A؂̐ӔCE`
//   𕉂܂BgpɂȂ̐ӔČɁǍʂ𕉂Ă
//   Bꂪ[Ȃ̂ł΁ApfOĂB
//
// rev  0
// date 2004/02/28
// auth fT
// memo TntR|Q̃[eBeBgp܂
//
// rev  1
// date 2004/03/12
// auth fT
// memo Network Object̔r
//      MinimizeNameUnicodeŒǉ
//
// rev  2
// date 2004/03/30-2004/05/10
// auth 
// memo TufBNg֐ǉ
//      ExpandUNCFilenameWideStringŒǉ
//      UpdateNetworkListW̃~XC(BeginRead->BeginWrite)
//      ^̃fBNgǂ𔻒肷֐ǉ
//      IsSubDirW̃~XC
//      DriveInfȍ𑝂₷
//      GetDropFileW̃~XC
//      UnicodeANSIւ̕ϊɁAϊłȂ邩
//      ǂ𔻒肷֐ǉ(CheckSafeConvW2A)
//
// rev  3
// date 2004/09/26
// auth 
// memo AyaGetDiskFreeSpaceWƕύX
// todo network resourcẽLbVf[^̌
//
// rev  4
// date 2004/12/03-
// auth 
// memo network resource֘AƏ
//      DragQueryFileWŎ擾t@C̃TCY𓮓IɎ擾
//      ɕύX
//
// rev  5
// date 2005/12/15
// auth 
// memo MAX_PATH_Wǉ
//
// rev  6
// date 2006/04/13 - 2006/xx/xx
// auth 
// memo PATH_PREFIX_Wǉ
//      GetDropFilesWōŌ̂PĂ~XC
//
// rev  7
// date 2008/10/18-2009/04/11
// auth 
// memo Delphi 2009ɈڐAJn
//      xxxWxxxU̎g : xxxWWideCharn, xxxU(Unicode)String
//      CheckSafeConvW2AWideCharUtilsɈړ
//      FillChar̃TCYw~X̏C
//      UpdateNetworkListU(srvname)̃~XC
//      Networkn̎葱E֐̍Đ݌v
//      ÂNetworkn̊֐netfuncsold unitɈړ
//      AyaTrueDirectoryExistsU'\\'(root)^ԂĂ~XC
//      {ȂUԂׂł
//      t@CVXe̍ő咷32Ɋg
//      GetVolumeInformationɃTufBNgnERROR_DIR_NOT_ROOT
//      ԂĂ̂ő΍.... > AyaGetVolumeInformation
//      t@CɂAnsiUpperCasegƁI@NTł̓t@Ĉ`
//      ͓I
//
// rev  8
// date 2009/05/15-2009/05/21
// auth 
// memo TServerObjU.GetCountAChildrenQƂO͕KOԂĂ
//      ~XC
//      ^CX^v̔rFAT̗pɂQbɐ؂グĔr֐
//      ǉ
//      ^CX^v̔rłQbȓȂ瓯ƌȂ֐ǉ
//
// rev  9
// date 2009/05/26
// auth 
// memo network object֘Aayanetobjsayanetutilɕ
//
//
// rev  10
// date 2009/07/08
// auth 
// memo GetVolumeNameForVolumeMountPointǉ
//
///////////////////////////////////////////////////////////////////////

interface

uses
  windows,messages,shellapi,sysutils,classes,timet,WideStrUtils,WideCharUtils,
  ayanetobjs, netapi32;

const
  MAX_PATH_W = 32000;  // \\?\C:\񂽂炩񂽂`̏ꍇ32000܂OK
  PATH_PREFIX_U : UnicodeString = '\\?\';
  YenW : WideChar = '\';
  MAX_FNAME  = 256;
  MAX_FOLDER_PATH = 249; // Folder̖O͍ő248܂

  faVolumeID = $00000008; // 񐄏AƂƂŒ`Ă...

type
  // drive֘A̒`
  TDriveIdDataW = record
    SerialNo : DWORD;
    VolName  : array[0..MAX_PATH] of WideChar;
  end;

  TDriveInfoDataU = record
    fsystem,
    volname : String;
    SerialNo : DWORD;
    TotalSize,FreeSize : Int64;
    MaxNameLen : DWORD;
    UnicodeStored : boolean;
    CasePreserved : boolean;
    CaseSensitive : boolean;
  end;

///////////////////////////////////////////////////////////////////////////
//
// Drive֘A̎葱E֐
//
///////////////////////////////////////////////////////////////////////////

// Drivȅ悢H
function CheckDriveReadyW(drv:widechar):boolean;

// w肳ꂽpX̏OK?
function CheckPathReadyU(path:String):boolean;

// DrivêH
function CheckDriveExistsU(drv:widechar):boolean;

// TufBNgnĂokGetVolumeInformation
function AyaGetVolumeInformation(lpRootPathName: PWideChar;
  lpVolumeNameBuffer: PWideChar; nVolumeNameSize: DWORD; lpVolumeSerialNumber: PDWORD;
  var lpMaximumComponentLength, lpFileSystemFlags: DWORD;
  lpFileSystemNameBuffer: PWideChar; nFileSystemNameSize: DWORD): BOOL; stdcall;

// Get VolumeLabel & SerialNumber
function GetVolAndSerialU(const path:String; var data:TDriveIdDataW):boolean;

// Get FileSystem,VolumeName,SerialNo,TotalSize,UsedSize
function GetDriveInfoU(trg:String; var data:TDriveInfoDataU):integer;

// get drive/dir capacity
function AyaGetDiskFreeSpaceW(Drv:PWideChar; var Total,Free:INT64):boolean;

// ̓hCuH(ݔł͂Ȃ̂ŒӁBx:\Ƃ`ǂ`FbN)
function IsRootDriveU(ADrv:String):boolean;

// hCuԍA-Z̊Ԃɂΐ^
function IsInA2Z(drv:WideChar):boolean;

//  Volume ǂ𔻒
function IsSameVolume(ATrg1,ATrg2:string):boolean;

///////////////////////////////////////////////////////////////////////////
//
// File֘A̎葱E֐
//
///////////////////////////////////////////////////////////////////////////

// abovetrueɂƁA\\srv\\share\.. -> \\srv
//        falseƁA   \\srv\\share\.. -> \\srv\share
// Ƃ܂BȊO͓B
function AyaExpandFilenameU(const Filename:String; const Above:boolean):string;

// .xxxx ƂOǂ`FbN
function CheckTopPeriodU(srcname:string):boolean;

// .xxxx Ƃt@C t@C{̂ .xxxxAgq͖A
// ňChangeFileExt
function ChangeFileExt2U(const FileName, Extension: string): string;

// .xxxx Ƃt@C t@C{̂ .xxxxAgq͖A
// ňExtractFileExt
function ExtractFileExt2U(const FileName:string): string;

// Zt@C𒷂t@Cɕϊ
function GetLongFilenameU(sn:string):string;

// dir1/dir2/filename -> dir1,dir2/filenamê悤ɕ
procedure DivideFilenameU(const src:string; var dir1,dir2:string);

// e|t@C쐬
function GetTmpFilenameU(prefix:String):String;

// J[Vuɍ폜
function AyaDeleteFileU(trg:string):integer;

// lamode=truêƂAŏIύXςȂrename
function AyaRenameU(org,new:string; lamode:boolean):integer;

// trg̃^CX^vcr,lw,laŐݒ^擾
function SetTimeStampU(const trg:string; const cr,lw,la:TDateTime):integer;
function GetTimeStampU(const trg:string; var cr,lw,la:TDateTime):integer;

// ExtractRelativePath̊g
// hCȗ΃pX擾
function AyaExtractRelativePathU(BaseName, DestName: string): string;

{* Sysutils.ExpandUNCFilenamêł
// ExpandUNCFilenameUnicode
function ExpandUNCFilenameU(const FileName:String):String;
 *}

// SUBSTƂĂhCu^fBNĝ̂ɖ߂
function ExpandFileNameExU(Target:string):string;

// lastWriteTime̔r
//   left̕V >0
//             Â   <0
//                =0
function CompareFileTimeExU(left,right:string):integer;

// CompareFileTimeExUƂقړATimeStampFATɋɊۂ߂
function CompareDosFileTimeExU(left,right:string; ARoundUp:boolean=true):integer;

// CompareFileTimeExUƂقړATimeStamp̍QbȓȂ瓯ƌȂ
function CompareFileTimeExU2Sec(left,right:string):integer;

// Compressed̐ݒE
function SetCompressedAttrU(name:string; c:boolean):integer;

// DiȑꍇADir̃t@CCompressedt
// SubDirCompressedt(SubDir=true, slp=trueƂPt@CƂSleep(0))
function SetCompressedAttrU2(const FileName: string; c,SubDir,slp:boolean): Integer;

// CompressedFileSetAttr()
// DiŕADir݂̂Ɉk
function AyaFileSetAttrU(const FileName: string; Attr: Integer): Integer;

// t@CƂĎgȂL邩ǂ`FbN
// LTRUEԂ
// R \ gȂȂ̂ŏɃt@Cn
function IsInvalidNameU(ATrg:String):boolean;

// version擾
function AyaGetFileVersionInfoU(const srcfile:string; var mjr,mnr,rel,bld:integer):DWORD;

///////////////////////////////////////////////////////////////////////////
//
// Directory֘A̎葱E֐
//
///////////////////////////////////////////////////////////////////////////

// i:\work\level,0 -> i:\
//              ,1 -> i:\work
//              ,2 -> i:\work\level
// \\unc\name\work\level,0  -> \\unc\name
//                      ,1  -> \\unc\name\work
//                      ,2  -> \\unc\name\work\level
//                      ,-1 -> \\unc
function ExtractDirLevelU(const src:string; const Level:integer):string;

// fBNg݃`FbN(UNCΉ)
function AyaDirectoryExistsU(const Name: string): Boolean;

// u^ṽfBNgH
function AyaTrueDirectoryExistsU(const Name: string): Boolean;

// JgfBNgݒ
function SetCurrentDirU(adir:String):boolean;

// removable device(or network)̃`FbN
function CheckRemovableU(trg:string):boolean;

// ̊KwɓnăfBNg
// Delphi2009łForceDirectories֐̖肪Ă̂ŃiV
//procedure AyaForceDirectoriesU(dir:String);

// S~fBNgǂ`FbN(蔲ver.)
function CheckDustBoxU(const trg:String):boolean;

// ϐɃJghCuo^
function SetCurDrvToEnvU(curdir:String):DWORD;

// JgfBNgݒAъϐɔf
function SetCurDirAndEnvU(dir:String):DWORD;

// ϐJghCuNA
function ClearCurDrvFromEnvU(curdir:String):DWORD;

// ̓fBNgH
function IsDirectoryU(const Name:String):boolean;

// JgfBNg̎擾
function GetCurrentDirU:String;

// TufBNg
// ATrgDirABaseDir̃TufBNgȂΐ^
// SUBST΍Ă
function IsSubDirU(ABaseDir,ATrgDir:String):boolean;


///////////////////////////////////////////////////////////////////////////
//
// UNC֘A̎葱E֐
//   IsUNCPathU,IsUNCServerU,IsUNCShareNameUUNCƂĐǂ
//   `FbNĂ邾ŁA݂Ă邩ǂ͊֌WL܂B
//   ݂Ă邩ǂIsUNCExistWgpĂB
//   \\?\drv:`UNCƂĈĂ܂
//
///////////////////////////////////////////////////////////////////////////
function IsUNCPathU(trg:String):boolean;
function IsUNCServerU(trg:String):boolean;
function IsUNCShareNameU(trg:String):boolean;

function IsUNCExistU(trg:String; dwType:DWORD):boolean;

//////////////////////////////////////////////////////////////////////////
//
// Network֘A̎葱E֐
//
//////////////////////////////////////////////////////////////////////////

function GetMyMachineName:string; // @̃}V
function GetBelongDomainName(AName:string):string; overload; // ANameworkgroup or domain
function GetBelongDomainName:string; overload;               // @workgroup or domain

function NeedPasswdU(trgunc:string):TPasswdType;
function GetNetworkErrorU(var ErrCode:DWORD; var ErrMsg,Provider:string):boolean;
function GetUNCNameU(trg:string; dwType:DWORD; var rightstr:string):boolean;

//////////////////////////////////////////////////////////////////////////
//
// ̑
//
//////////////////////////////////////////////////////////////////////////

// \L邩
function CountYenU(srcname:string):integer;

// spaceLΗ[ " t
function AddDoubleQuatU(const trgname:string):string;

// hbvꂽt@C̃Xg쐬B݂
// LongFilenameɕϊĂ
function GetDropFilesU(var msg:TWmDropFiles):TStringList;

// MinimizeNameUnicode -> pӂĂ̂ŃiV
//function MinimizeNameW(const AFilename:WideString; ACanvas:TCanvas; MaxLen:integer):WideString;


//  \\?\Volume{GUID}\ ȂuniquenameԂ
function GetVolumeNameForVolumeMountPoint(
          lpszVolumeMountPoint,      // ̓}Eg|Cg܂̓fBNg
          lpszVolumeName:PWideChar;  // o̓{[obt@
          cchBufferLength:DWORD      // {[obt@̃TCY
         ):BOOL; stdcall;

implementation

uses
  ayanetutilu,reparseutils;

/////////////////////////////////////////////////////////////////////////////
//
// Drive֘A
//
/////////////////////////////////////////////////////////////////////////////

function IsInA2Z(drv:WideChar):boolean;
begin
  drv:=UpCase(drv);
  result:=CharInSet(drv,['A'..'Z']);
end;

// hCu`FbN
function CheckDriveReadyW(drv:widechar):boolean;
var
  sv : integer;
begin
  drv:=UpCase(Drv);
  IF NOT IsInA2Z(drv) THEN BEGIN
    result:=false; Exit;
  END;
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    result:=DiskSize(ord(drv)-ord(WideChar('A'))+1)<>-1;
  finally
    SetErrorMode(sv);
  end;
end;

function CheckPathReadyU(path:string):boolean;
var
  sv : integer;
  FreeB,TotalB,TFreeB : INT64;
begin
  result:=false;
  IF Path='' THEN Exit;
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    IF IsUNCPathU(path) AND (WideLastChar(path)^<>YenW) THEN Path:=Path+YenW;
    result:=GetDiskFreeSpaceExW(PWideChar(path),FreeB,TotalB,@TFreeB);
  finally
    SetErrorMode(sv);
  end;
end;

function CheckDriveExistsU(drv:widechar):boolean;
var
  d : DWORD;
  i : integer;
begin
  drv:=UpCase(Drv);
  IF NOT IsInA2Z(drv) THEN BEGIN
    result:=false; Exit;
  END;
  d:=GetLogicalDrives;
  i:=Ord(UpCase(drv))-Ord(WideChar('A'));
  d:=(d shr i) AND 1;
  result:=(d=1);
end;

function AyaGetVolumeInformation(lpRootPathName: PWideChar;
  lpVolumeNameBuffer: PWideChar; nVolumeNameSize: DWORD; lpVolumeSerialNumber: PDWORD;
  var lpMaximumComponentLength, lpFileSystemFlags: DWORD;
  lpFileSystemNameBuffer: PWideChar; nFileSystemNameSize: DWORD): BOOL;
var
  workdir : string;
  sts : DWORD;
  done : boolean;
begin
  result:=false;
  workdir:=lpRootPathName;
  REPEAT
    done:=GetVolumeInformation(PWideChar(workdir),
                               lpVolumeNameBuffer,nVolumeNameSize,
                               lpVolumeSerialNumber,
                               lpMaximumComponentLength,
                               lpFileSystemFlags,
                               lpFileSystemNameBuffer,nFileSystemNameSize);
    if NOT done then begin
      sts:=GetLastError;
      if sts=ERROR_DIR_NOT_ROOT then begin
        // tH_[ĕԂ
        if IsRootDriveU(workdir) OR IsUNCServerU(workdir) then begin
          // ?:\ or \\hoge\hugaȂG[ŕԂ
          done:=true;
          result:=false;
        end else begin
          if workdir[length(workdir)]='\' then workdir:=copy(workdir,1,length(workdir)-1);
          workdir:=ExtractFilePath(workdir);
        end;
      end else begin
        // ȊO̓G[ŕԂ
        done:=true;
        result:=false;
      end;
    end else
      result:=true;
  UNTIL done;
end;

function GetVolAndSerialU(const path:String; var data:TDriveIdDataW):boolean;
const
  FSNLEN = 16;
var
  fsn : array[0..FSNLEN] of WideChar;
  dummy,flags : DWORD;
  work : WideString;
begin
  result:=false;
  work:=AyaExpandFilenameU(path,true);
  // UNC Path΍
  IF IsUNCPathU(work) THEN BEGIN
    IF CountYenU(work)<3 THEN Exit;
    // UNC̏ꍇAŌ \ łȂ΂ȂȂ
    IF WideLastChar(work)^<>'\' THEN work:=work+'\';
  END ELSE
    work:=PATH_PREFIX_U+work; // \\?\drv:\ɕϊĂI
  //
  FillChar(data.VolName[0],(MAX_PATH+1)*sizeof(WideChar),0);
  FillChar(fsn,sizeof(fsn),0);
  result:=AyaGetVolumeInformation(PWideChar(work),@(data.VolName[0]),MAX_PATH,@(data.SerialNo),dummy,flags,fsn,FSNLEN);
end;

// windows.pasGetDiskFreeSpaceExW̒`ρHȂ̂...
function __GetDiskFreeSpaceExW(lpDirectoryName: PWideChar;
         lpFreeBytesAvailableToCaller, lpTotalNumberOfBytes, lpTotalNumberOfFreeBytes: PLargeInteger): BOOL; stdcall;
         external kernel32 name 'GetDiskFreeSpaceExW';

function AyaGetDiskFreeSpaceW(Drv:PWideChar; var Total,Free:INT64):boolean;
var
  SecPerClus,BytePerSec,FrClus,Clus : DWORD;
  w1,w2 : INT64;
  liFBAtC,liTNoB,liTNoFB : TLargeInteger;
begin
  result:=false;
  IF __GetDiskFreeSpaceExW(Drv,@liFBAtC,@liTNoB,@liTNoFB) THEN BEGIN
    result:=true;
    Total:=liTNoB; Free:=liTNoFB;
  END ELSE IF GetDiskFreeSpaceW(drv,SecPerClus,
                          BytePerSec,FrClus,Clus) THEN BEGIN
    w1:=SecPerCLus; w2:=BytePerSec; w1:=w1*w2;
    w2:=Clus;
    total:=w1*w2;
    w2:=FrClus;
    free:=w1*w2;
    result:=true;
  END;
end;

function IsRootDriveU(ADrv:String):boolean;
begin
  result:=false;
  IF Length(ADrv)<>3 THEN Exit;
  result:= IsInA2Z(ADrv[1]) AND (':\'=Copy(ADrv,2,2));
end;

// hCu擾
function GetDriveInfoU(trg:String; var data:TDriveInfoDataU):integer;
const
  MaxFS = 32;
var
  drv : String;
  voln:array[0..MAX_PATH] of widechar;
  fsn : array[0..MaxFS] of widechar;
  flags : DWORD;
  w1,w2 : INT64;
  ASrvObj : TNetResourceObjU;
begin
  result:=0;
  data.totalsize:=0; data.freesize:=0; data.SerialNo:=0; data.MaxNameLen:=0;
  data.fsystem:='????'; data.volname:='???';
  data.UnicodeStored:=false; data.CasePreserved:=false; data.CaseSensitive:=false;
  IF trg='' THEN
    Exit
  ELSE IF trg='\\' THEN BEGIN
    data.fsystem:='ROOT'; data.volname:=''; data.UnicodeStored:=True; Exit;
  END ELSE IF IsUNCServerU(trg) THEN BEGIN
    IF WideLastChar(trg)^='\' THEN SetLength(trg,Length(trg)-1);
    try
      ASrvObj:=FindAndDupUNCObj(trg);
      IF ASrvObj<>nil THEN BEGIN
        try
          if ASrvObj is TServerObjU then begin
            data.fsystem:='SRV';
            data.volname:=ASrvObj.Comment;
            data.UnicodeStored:=true;
          end;
        finally
          ASrvObj.free;
        end;
      END;
    except ON EInvalidCast do
      ; // Ƃ肠X[
    end;
    Exit;
  END ELSE IF IsUNCPathU(trg) THEN BEGIN
    drv:=ExtractDirLevelU(trg,0);
    IF WideLastChar(drv)^<>'\' THEN drv:=drv+'\';
  END ELSE
    drv:=copy(trg,1,3);
  FillChar(fsn,sizeof(fsn),0);
  FillChar(voln[0],sizeof(voln),0);
  IF GetVolumeInformationW(PWideChar(drv),@voln[0],MAX_PATH,@(data.SerialNo),data.MaxNameLen,flags,fsn,MaxFS) THEN BEGIN
    data.volname:=voln;
    IF (data.MaxNameLen>12) AND (String(fsn)='FAT') THEN
      data.fsystem:='VFAT'
    ELSE IF fsn='' THEN
      data.fsystem:='????' // IĂlłȂꍇL݂
    ELSE
      data.fsystem:=fsn;
    data.UnicodeStored:=0<>(flags AND FS_UNICODE_STORED_ON_DISK);
    data.CasePreserved:=0<>(flags AND FS_CASE_IS_PRESERVED);
    data.CaseSensitive:=0<>(flags AND FS_CASE_SENSITIVE);
  END ELSE BEGIN
    result:=GetLastError;
    IF result=ERROR_BAD_LENGTH THEN BEGIN
      // Ȃꍇ́AȂĂi[
      data.fsystem:=fsn;
      data.volname:=voln;
      //
      data.UnicodeStored:=0<>(flags AND FS_UNICODE_STORED_ON_DISK);
      data.CasePreserved:=0<>(flags AND FS_CASE_IS_PRESERVED);
      data.CaseSensitive:=0<>(flags AND FS_CASE_SENSITIVE);
    END ELSE BEGIN
      // ȊO͖mĂƂ
      data.fsystem:='????';
      data.volname:='???';
    END;
  END;
  //
  IF AyaGetDiskFreeSpaceW(PWideChar(drv),w1,w2) THEN BEGIN
    data.totalsize:=w1;
    data.freesize:=w2;
  END ELSE BEGIN
    data.totalsize:=0; data.freesize:=0;
  END;
end;

function IsSameVolume(ATrg1,ATrg2:string):boolean;
var
  s1,s2,d1,d2 : DWORD;
  function TailYen(src:string):string;
  begin
    if src[Length(src)]<>'\' then
      result:=src+'\'
    else
      result:=src;
  end;
begin
  result:=false;
  ATrg1:=TailYen(ExpandReparseName(ATrg1));
  ATrg2:=TailYen(ExpandReparseName(ATrg2));
  if AyaGetVolumeInformation(PWideCHar(ATrg1),nil,0,@s1,d1,d2,nil,0) and
     AyaGetVolumeInformation(PWideCHar(ATrg2),nil,0,@s2,d1,d2,nil,0) then begin
    // 擾ł > {[ǂ`FbN
    result:=(s1<>0) and (s1=s2);
  end;
end;

///////////////////////////////////////////////////////////////////////////
//
// File֘A̎葱E֐
//
///////////////////////////////////////////////////////////////////////////

function AyaExpandFilenameU(const Filename:String; const Above:boolean):string;
const
  PrW = '.';
  YenPYen  = '\.\';
  YenPPYen = '\..\';
  YenP     = '\.';
  YenPP    = '\..';
var
  work,work2 : String;
  fl,i : integer;
begin
  result:='';  fl:=Length(Filename);
  // O
  IF fl=0 THEN Exit;
  // root...
  IF NetRootU=Filename THEN BEGIN
    result:=NetRootU; Exit;
  END;
  // P or UNCw肶ȂExpandFilenameŕԂ
  IF (fl=1) OR (NOT IsUNCPathU(Filename)) THEN BEGIN
    result:=ExpandFilename(Filename); Exit;
  END;
  // UNCꍇcc
  // \\. \\.. -> \\
  // \\srv -> \\srv
  // \\srv\. -> \\srv
  // \\srv\.. -> \\
  // \\srv\shr \\srv\shr\. -> \\srv\shr
  // \\srv\shr\.. -> \\srv
  work:='';
  FOR i:=1 TO fl DO BEGIN
    work:=work+Filename[i];
    IF YenPYen=Copy(work,Length(work)-2,3) THEN BEGIN
      SetLength(work,Length(work)-2);
    END ELSE IF YenPPYen=Copy(work,Length(work)-3,4) THEN BEGIN
      work2:=copy(work,1,Length(work)-4);
      IF (work2<>YenW) AND (IsUNCServerU(work2) OR IsUNCSharenameU(work2)) AND (NOT Above) THEN BEGIN
        SetLength(work,Length(work)-3);
      END ELSE BEGIN
        SetLength(work,Length(work)-4);
        WHILE WideLastChar(work)^<>YenW DO SetLength(work,Length(work)-1);
      END;
      IF Length(work)<2 THEN work:=NetRootU;
    END;
  END;
  IF YenP=Copy(work,Length(work)-1,2) THEN BEGIN
    SetLength(work,Length(work)-2);
  END ELSE IF YenPP=Copy(work,Length(work)-2,3) THEN BEGIN
    work2:=copy(work,1,Length(work)-3);
    IF (work2<>YenW) AND (IsUNCServerU(work2) OR IsUNCSharenameU(work2)) AND (NOT Above) THEN BEGIN
      SetLength(work,Length(work)-3);
    END ELSE BEGIN
      SetLength(work,Length(work)-3);
      WHILE WideLastChar(work)^<>YenW DO SetLength(work,Length(work)-1);
      SetLength(work,Length(work)-1);
    END;
  END;
  IF Length(work)<2 THEN work:=NetRootU;
  result:=work;
end;

function CheckTopPeriodU(srcname:string):boolean;
var
  work : string;
begin
  result:=false;
  IF Length(srcname)=0 THEN Exit;
  work:=ExtractFilename(srcname);
  IF length(work)=0 THEN Exit;
  result:=(work[1]=WideChar('.')) AND (ChangeFileExt(work,'')='');
end;

function ChangeFileExt2U(const FileName, Extension: string): string;
var
  work : string;
begin
  IF CheckTopPeriodU(Filename) THEN BEGIN
    IF Length(Extension)=0 THEN
      work:=''
    ELSE IF Extension[1]=WideChar('.') THEN
      work:=Extension
    ELSE
      work:='.'+Extension;
    result:=Filename+work;
  END ELSE
    result:=ChangeFileExt(FileName,Extension);
end;

function ExtractFileExt2U(const FileName:string): string;
begin
  IF CheckTopPeriodU(Filename) THEN
    result:=''
  ELSE
    result:=ExtractFileExt(FileName);
end;

function GetLongFilenameU(sn:string):string;
var
  workdir,workname,work :string;
  svmd : integer;
  function MakeIOErr(sts:integer; trg:string):EInOutError;
  begin
    Result:=EInOutError.Create(SysErrorMessage(sts)+#13#10+trg);
    Result.ErrorCode:=sts;
  end;
  function GetLongNameSub(sname:string):string;
  var
    sr : TSearchRec;
    sts: integer;
  begin
     result:='';
     sts:=FindFirst(sname,faAnyFile-faVolumeID,sr);
     IF 0=sts THEN BEGIN
       result:=sr.FindData.cFileName;
       FindClose(sr);
     END ELSE
       raise MakeIOErr(sts, sname);
  end;
  function UNCSub(trg:string):string;
  var
    i : integer;
  begin
    result:='';
    IF trg='' THEN Exit;
    IF wideLastChar(trg)^=YenW THEN SetLength(trg,Length(trg)-1);
    // \\server̊mF
    work:=ExtractDirLevelU(trg,-1);
    IF NOT GetUNCNameU(work,RESOURCETYPE_ANY,workdir) THEN
      MakeIOErr(ERROR_BAD_NET_NAME,workdir);
    IF 0=AnsiCompareText(trg,work) THEN BEGIN // trg=\\server
      result:=workdir; Exit;
    END;
    // \\server\sharename̊mF
    work:=ExtractDirLevelU(trg,0);
    IF NOT GetUNCNameU(work,RESOURCETYPE_ANY,workdir) THEN
      MakeIOErr(ERROR_BAD_NET_NAME,workdir);
    IF 0=AnsiCompareText(trg,work) THEN BEGIN // trg=\\server
      result:=workdir; Exit;
    END;
    // trg\\server\\sharenameuv̂ɒu
    work:=workdir;
    trg:=work+copy(trg,Length(work)+1,Length(trg)-Length(work));
    // \\server\sharename\...̊mF
    svmd:=SetErrorMode(SEM_FAILCRITICALERRORS);
    try
      i:=Length(work); workname:=trg; work:='';
      IF length(workname)=i THEN BEGIN
        workdir:=workname;
      END ELSE BEGIN
        REPEAT
          workdir:=ExtractFileDir(workname);
          IF work='' THEN
            work:=GetLongNameSub(workname)
          ELSE
            work:=GetLongNameSub(workname)+'\'+work;
          workname:=workdir;
        UNTIL Length(workname)<=i;  // \\server\sharenameɂȂI
      END;
    finally
      SetErrorMode(svmd);
    end;
    result:=workdir+'\'+work;
  end;
  function DrvSub(trg:string):string;
  begin
    result:='';
    trg[1]:=UpCase(trg[1]);
    // ?:\aaa\bb\...̏ꍇ
    IF NOT CheckDriveExistsU(trg[1]) THEN
      MakeIOErr(ERROR_INVALID_DRIVE,trg[1]+':\'); // ̃hCu͂Ȃ
    // ?:\̂΂₢
    IF IsRootDriveU(trg) THEN BEGIN
      result:=trg; Exit;
    END;
    IF (WideLastChar(trg)^)=YenW THEN SetLength(trg,Length(trg)-1);
    svmd:=SetErrorMode(SEM_FAILCRITICALERRORS);
    try
      workname:=trg; work:='';
      IF length(workname)=3 THEN BEGIN
        workdir:=workname;
      END ELSE BEGIN
        REPEAT
          workdir:=ExtractFileDir(workname);
          IF work='' THEN
            work:=GetLongNameSub(workname)
          ELSE
            work:=GetLongNameSub(workname)+'\'+work;
          workname:=workdir;
        UNTIL Length(workname)=3;  // '?:\'ɂȂI
      END;
    finally
      SetErrorMode(svmd);
    end;
    result:=workdir+work;
  end;
begin
  result:='';
  // 󕶎̏ꍇ͂ŏI
  IF sn='' THEN Exit;
  sn:=AyaExpandFilenameU(sn,true);
  IF sn=NetRootU THEN
    result:=sn
  ELSE IF IsUNCPathU(sn) THEN
    result:=UNCSub(sn)   // UNC̏ꍇ
  ELSE
    result:=DrvSub(sn);  // LocalDrv̏ꍇ
end;

procedure DivideFilenameU(const src:string; var dir1,dir2:string);
var
  unc : boolean;
  i,j : integer;
begin
  // 󕶎΍
  IF Length(src)=0 THEN BEGIN
    dir1:=''; dir2:=''; Exit;
  END;
  //
  i:=1; j:=0;
  unc:=IsUNCPathU(src);
  REPEAT
    IF (src[i]='/') OR (src[i]=YenU) THEN BEGIN
      IF (NOT unc) OR (i>3) THEN BEGIN
        j:=i; break;
      END;
    END;
    INC(i);
  UNTIL i>Length(src);
  IF j=0 THEN BEGIN  // \Ȃ
    dir1:=src;
    dir2:='';
  END ELSE BEGIN
    dir1:=Copy(src,1,j-1);
    dir2:=Copy(src,j+1,Length(src)-j);
  END;
end;

function GetTmpFilenameU(prefix:String):String;
var
  tmpdir,tmpname : array[0..MAX_PATH] of widechar;
begin
  result:='';
  FillChar(tmpdir,sizeof(tmpdir),0);
  IF 0=GetTempPathW(MAX_PATH,tmpdir) THEN Exit;
  FillChar(tmpname,sizeof(tmpname),0);
  IF 0=GetTempFileNameW(tmpdir,PWideChar(prefix),0,tmpname) THEN Exit;
  result:=tmpname;
end;

function AyaDeleteFileU(trg:String):integer;
  function DirectoryExists(const Name: String): Boolean;
  var
    Code: Integer;
  begin
    Code := GetFileAttributesW(PWideChar(Name));
    Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
  end;
  function MyDeleteFile(trg:string):integer;
  begin
    result:=FileSetAttr(trg,0);
    IF result<>0 THEN Exit;
    IF DeleteFile(trg) THEN
      result:=0
    ELSE
      result:=GetLastError;
  end;
  function MyDeleteDir(trg:string):integer;
  var
    sr : TSearchRec;
    sts : integer;
  begin
    result:=FileSetAttr(trg,0);
    IF result<>0 THEN Exit;
    sts:=FindFirst(trg+'\*.*',faAnyFile-faVolumeID,sr);
    IF sts=0 THEN BEGIN
      try
        REPEAT
          IF (sr.attr AND faDirectory)=0 THEN BEGIN
            result:=MyDeleteFile(trg+YenW+sr.name);
          END ELSE BEGIN
            IF (sr.name<>'.') AND (sr.name<>'..') THEN BEGIN
              result:=MyDeleteDir(trg+YenW+sr.name);
            END;
          END;
        UNTIL (0<>FindNext(sr)) OR (result<>0);
      finally
        FindClose(sr);
      end;
    END ELSE
      result:=sts;
    IF result=0 THEN BEGIN
      IF NOT RemoveDir(trg) THEN result:=GetLastError;
    END;
  end;
var
  sv : integer;
begin
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    IF FileExists(trg) THEN
      result:=MyDeleteFile(trg)
    ELSE IF DirectoryExists(trg) THEN
      result:=MyDeleteDir(trg)
    ELSE
      result:=ERROR_FILE_NOT_FOUND;
  finally
    SetErrorMode(sv);
  end;
end;

function AyaRenameU(org,new:string; lamode:boolean):integer;
var
  sv : integer;
  cr,lw,la:TDateTime;
begin
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    IF lamode THEN GetTimeStampU(org,cr,lw,la);
    IF RenameFile(org,new) THEN
      result:=0
    ELSE
      result:=GetLastError;
    IF lamode THEN SetTimeStampU(new,0,0,la);
  finally
    SetErrorMode(sv);
  end;
end;

// ύX̕⏕
function SetTimeStampSubU(const trg:string; flag:DWORD; const cr,lw,la:TDateTime):integer;
var
  shandle : THandle;
  crt,lwt,lat : TFileTime;
  pcrt,plwt,plat : PFileTime;
  sv : integer;
begin
  result:=0;
  try
    crt:=DateTimeToFileTime(cr);
    pcrt:=@crt;
  except
    ON EConvertError DO
      pcrt:=nil;
  end;
  try
    lwt:=DateTimeToFileTime(lw);
    plwt:=@lwt;
  except
    ON EConvertError DO
      plwt:=nil;
  end;
  try
    lat:=DateTimeToFileTime(la);
    plat:=@lat;
  except
    ON EConvertError DO
      plat:=nil;
  end;

  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    shandle:=CreateFileW(PWideChar(trg),GENERIC_WRITE,0,
                        nil,OPEN_EXISTING,flag,0);
    IF shandle=INVALID_HANDLE_VALUE THEN BEGIN
      result:=GetLastError;
    END ELSE BEGIN
      IF NOT SetFileTime(shandle,pcrt,plat,plwt) THEN result:=GetLastError;
      CloseHandle(shandle);
    END;
  finally
    SetErrorMode(sv);
  end;
end;


// trg̃^CX^vcr,lw,laŐݒ^擾
function SetTimeStampU(const trg:string; const cr,lw,la:TDateTime):integer;
begin
  IF IsDirectoryU(trg) THEN
    result:=SetTimeStampSubU(trg,FILE_ATTRIBUTE_NORMAL OR FILE_FLAG_BACKUP_SEMANTICS,cr,lw,la)
  ELSE
    result:=SetTimeStampSubU(trg,FILE_ATTRIBUTE_NORMAL,cr,lw,la);
end;

function GetTimeStampU(const trg:string; var cr,lw,la:TDateTime):integer;
var
  sr : TSearchRec;
  sv : integer;
begin
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    result:=FindFirst(trg,faAnyFile-faVolumeID,sr);
    IF result=0 THEN BEGIN
      try
        // 쐬t  FAT32NTFS
        WITH sr.FindData DO BEGIN
          cr:=0.0;
          IF (ftCreationTime.dwLowDateTime<>0) AND (ftCreationTime.dwHighDateTime<>0) THEN BEGIN
            try
              cr:=FileTimeToDateTime(ftCreationTime);
            except
              ON EConvertError DO  // ϊs͖ȓtƂĈ
                ;
            end;
          END;
        END;
        // ŏIANZXt  FAT32NTFS
        WITH sr.FindData DO BEGIN
          la:=0.0;
          IF (ftLastAccessTime.dwLowDateTime<>0) AND (ftLastAccessTime.dwHighDateTime<>0) THEN BEGIN
            try
              la:=FileTimeToDateTime(ftLastAccessTime);
            except
              ON EConvertError DO  // ϊs͖ȓtƂĈ
                ;
            end;
          END;
        END;
        // ŏIύXt
        //lw:=FileDateToDateTime($00210000);  // 1980/01/01 00:00:00
        lw:=DT19800101;
        try
          lw:=FileTimeToDateTime(sr.FindData.ftLastWriteTime);
        except
          On EConvertError DO  // ϊs 80/01/01 00:00:00ƂĈ
            ;
        end;
      finally
        FindClose(sr);
      end;
    END;
  finally
    SetErrorMode(sv);
  end;
end;

//
// ExtractRelativePath
//
// BaseName = ƂȂufBNgv
// DestName = Ήut@C(fBNg)v
//
// BaseName,   DestName     -> result
// X:\foo      Y:\bar          Y:\bar
// X:\foo      X:\foo\bar      bar
// X:\foo\bar  X:\foo          ..\   // ̏ꍇ͕KfBNg
// X:\foo      X:\bar          ..\bar
// X:\         X:\bar          bar
// X:\foo      X:\             ..\
//
function AyaExtractRelativePathU(BaseName, DestName: string): string;
  //  x:\foo1\bar1 y:\foo2\bar2 Ƃ`ΏۂƂ
  function GetSameDir(dir1,dir2:string):string;
  var
    i,MIN : integer;
  begin
    result:='';
    MIN:=CountYenU(dir1); IF CountYenU(dir2)<MIN THEN MIN:=CountYenU(dir2);
    FOR i:=0 TO MIN DO BEGIN
      IF 0=AnsiCompareText(ExtractDirLevelU(dir1,i),ExtractDirLevelU(dir2,i)) THEN
        result:=ExtractDirLevelU(dir1,i)
      ELSE
        break;
    END;
  end;
var
  cm,cmr : WideString;
  i : integer;
begin
  BaseName:=AyaExpandFilenameU(BaseName,false);
  DestName:=AyaExpandFilenameU(DestName,false);
  cm:=GetSameDir(BaseName,DestName);
  IF cm<>'' THEN BEGIN
    // ʃfBNg(܂ރhCu)
    IF Length(cm)>3 THEN BEGIN    // cm = x:\foo\bar , cmr = x:\foo\bar\
      cmr:=cm+YenU;
    END ELSE BEGIN
      cmr:=cm; cm:=copy(cm,1,2);
    END;
    BaseName:=copy(BaseName,Length(cm)+1,Length(BaseName)-Length(cm));
    DestName:=copy(DestName,Length(cmr)+1,Length(DestName)-Length(cmr));
    result:='';
    IF BaseName<>YenU THEN  // BaseName='\' -> ʕx:\
      FOR i:=1 TO CountYenU(BaseName) DO
        result:=result+'..\';
    result:=result+DestName;
    IF result='' THEN result:=WideString('.\'); // BaseName=DestName
  END ELSE
    // ʃfBNgȂ
    result:=DestName;
end;

function ExpandFileNameExU(Target:String):String;
var
  buf : array[0..MAX_PATH] of WideChar;
  src,dir : String;
  i : integer;
begin
  target:=ExpandFilename(target);
  src:=copy(target,1,2);
  FillChar(buf[0],sizeof(buf),0);
  IF QueryDosDeviceW(PWideChar(src),buf,MAX_PATH)=0 THEN
    result:=target // error̂łƂ肠tpX
  ELSE BEGIN
    src:=buf;
    i:=Pos('\??\',src);
    IF i=0 THEN // zhCuł͂Ȃ
      result:=target
    ELSE BEGIN  // zhCuł
      dir:=Copy(src,i+4,Length(src)-i-3);
      IF Length(dir)=3 THEN dir:=copy(dir,1,2); // X:\ -> X:
      result:=dir+copy(target,3,Length(target)-2);
    END;
  END;
end;

// lastWriteTime̔r
//   left̕V >0
//             Â   <0
function CompareFileTimeExU(left,right:string):integer;
var
  sr : TSearchRec;
  lt,rt : TFileTime;
  checknum : integer;
begin
  result:=0; checknum:=0;
  IF FindFirst(left,faAnyFile-FaVolumeID,sr)=0 THEN BEGIN
    try
      lt:=sr.FindData.ftLastWriteTime;
      INC(Checknum);
    finally
      FindClose(sr);
    END;
  end;
  IF FindFirst(right,faAnyFile-FaVolumeID,sr)=0 THEN BEGIN
    try
      rt:=sr.FindData.ftLastWriteTime;
      INC(Checknum);
    finally
      FindClose(sr);
    END;
  end;
  IF checknum<2 THEN Exit;
  result:=CompareFileTime(lt,rt);
end;

function CompareDosFileTimeExU(left,right:string; ARoundUp:boolean):integer;
var
  sr : TSearchRec;
  lt,rt,ldt,rdt : TFileTime;
  checknum : integer;
begin
  result:=0; checknum:=0;
  IF FindFirst(left,faAnyFile-FaVolumeID,sr)=0 THEN BEGIN
    try
      lt:=sr.FindData.ftLastWriteTime;
      INC(Checknum);
    finally
      FindClose(sr);
    END;
  end;
  IF FindFirst(right,faAnyFile-FaVolumeID,sr)=0 THEN BEGIN
    try
      rt:=sr.FindData.ftLastWriteTime;
      INC(Checknum);
    finally
      FindClose(sr);
    END;
  end;
  IF checknum<2 THEN Exit;

  // FAT2bPʂɊۂ߂
  try
    ldt:=DateTimeToFileTime(DateTimeToDosTime(FileTimeToDateTime(lt),ARoundUp));
    rdt:=DateTimeToFileTime(DateTimeToDosTime(FileTimeToDateTime(rt),ARoundUp));
    result:=CompareFileTime(ldt,rdt);
  except
    ON EConvertError DO
      result:=CompareFileTime(lt,rt);
  end;
end;

var
 DT2Sec : TDateTime;

function CompareFileTimeExU2Sec(left,right:string):integer;
var
  sr : TSearchRec;
  lt,rt : TFileTime;
  checknum : integer;
  dt,ldt,rdt : TDateTime;
begin
  result:=0; checknum:=0;
  IF FindFirst(left,faAnyFile-FaVolumeID,sr)=0 THEN BEGIN
    try
      lt:=sr.FindData.ftLastWriteTime;
      INC(Checknum);
    finally
      FindClose(sr);
    END;
  end;
  IF FindFirst(right,faAnyFile-FaVolumeID,sr)=0 THEN BEGIN
    try
      rt:=sr.FindData.ftLastWriteTime;
      INC(Checknum);
    finally
      FindClose(sr);
    END;
  end;
  IF checknum<2 THEN Exit;
  try
    ldt:=FileTimeToDateTime(lt);
    rdt:=FileTimeToDateTime(rt);
    if ldt>=rdt then begin
      dt:=ldt-rdt;
      if dt>DT2Sec then
        result:=1
      else
        result:=0;
    end else begin
      dt:=rdt-ldt;
      if dt>DT2sec then
        result:=-1
      else
        result:=0;
    end;
  except
    ON EConvertError DO ;
  end;
end;

const
  FSCTL_SET_COMPRESSION =(9 SHL 16) OR (3 SHL 14) OR (16 SHL 2) OR 0;
{
CTL_CODE(FILE_DEVICE_FILE_SYSTEM,16, METHOD_BUFFERED, FILE_READ_DATA | FILE_WRITE_DATA)
#define CTL_CODE( DeviceType, Function, Method, Access ) (                 \
    ((DeviceType) << 16) | ((Access) << 14) | ((Function) << 2) | (Method) \
  FILE_DEVICE_FILE_SYSTEM         0x00000009
  METHOD_BUFFERED                 0
#define FILE_READ_ACCESS          ( 0x0001 )    // file & pipe
#define FILE_WRITE_ACCESS         ( 0x0002 )    // file & pipe

  CTL_CODE(9,16,0,3)=(9 SHL 16) OR (3 SHL 14) OR (16 SHL 2) OR 0

}
  COMPRESSION_FORMAT_NONE    : WORD = 0;
  COMPRESSION_FORMAT_DEFAULT : WORD = 1;
  COMPRESSION_FORMAT_LZNT1   : WORD = 2;

function SetCompressedAttrU(name:String; c:boolean):integer;
var
  h : THandle;
  cv : WORD;
  r : DWORD;
begin
  h:=CreateFileW(PWideChar(name),
                GENERIC_WRITE, //GENERIC_READ OR GENERIC_WRITE,
                0,
                nil,
                OPEN_EXISTING,
                //                       Dir̎ɕKv
                FILE_ATTRIBUTE_NORMAL OR FILE_FLAG_BACKUP_SEMANTICS,
                0);
  result:=GetLastError;
  IF (result<>0) AND (result<>ERROR_ALREADY_EXISTS) THEN Exit;
  //
  try
    IF c THEN cv:=COMPRESSION_FORMAT_DEFAULT ELSE cv:=COMPRESSION_FORMAT_NONE;
    IF DeviceIoControl(h,                       // hDevice
                       FSCTL_SET_COMPRESSION,   // dwIoControlCode
                       @cv,                     // lpInBuffer
                       2,                       // nInBufferSize
                       nil,                     // lpOutBuffer
                       0,                       // nOutBufferSize
                       r,                       // lpBytesReturned
                       nil) THEN                // lpOverlapped
      result:=0
    ELSE
      result:=GetLastError;
  finally
    CloseHandle(h);
  end;
end;

function SetCompressedAttrU2(const FileName: string; c,SubDir,slp:boolean): Integer;
var
  sr : TSearchRec;
begin
  IF AyaDirectoryExistsU(Filename) THEN BEGIN
    // ܂
    result:=SetCompressedAttrU(Filename,c);
    IF result<>0 THEN Exit;
    result:=FindFirst(Filename+WideString('\*.*'),faAnyFile-FaVolumeID,sr);
    IF result=0 THEN BEGIN
      try
        REPEAT
          IF (sr.Attr AND faDirectory)<>0 THEN BEGIN
            IF SubDir AND (sr.name<>'.') AND (sr.name<>'..') THEN
              result:=SetCompressedAttrU2(Filename+YenW+sr.name,c,SubDir,slp);
          END ELSE
            result:=SetCompressedAttrU(Filename+YenU+sr.name,c);
          IF slp THEN Sleep(0);
        UNTIL (0<>FindNext(sr)) OR (result<>0);
      finally
        FindClose(sr);
      end;
    END;
  END ELSE
    // Filȅꍇ͒P:-
    result:=SetCompressedAttrU(Filename,c);
end;

function AyaFileSetAttrU(const FileName: string; Attr: Integer): Integer;
var
  chk:integer;
begin
  result:=0;
  // ȂpX:-
  chk:=FileGetAttr(Filename);
  IF chk=-1 THEN BEGIN
    result:=GetLastError;
    Exit;
  END;
  IF Attr=chk THEN Exit;
  // CompressedύXKvȂAύX
  IF (chk AND FILE_ATTRIBUTE_COMPRESSED)<>(attr AND FILE_ATTRIBUTE_COMPRESSED) THEN
    SetCompressedAttrU(Filename, (ATTR AND FILE_ATTRIBUTE_COMPRESSED)<>0);
  // CompressedNAĂ
  Attr:=Attr AND (NOT FILE_ATTRIBUTE_COMPRESSED);
  result:=FileSetAttr(FileName,Attr);
end;

function IsInvalidNameU(ATrg:String):boolean;
var
  i : integer;
begin
  result:=false;
  for I := 1 to Length(ATrg) do
    if CharInSet(ATrg[i],['\','/',':','*','?','"','<','>','|']) then begin
      result:=true; exit;
    end;
end;

// version擾
function AyaGetFileVersionInfoU(const srcfile:string; var mjr,mnr,rel,bld:integer):DWORD;
var
  sz,dmy : DWORD;
  udmy   : UINT;
  pVerInfo,pInfo : pointer;
begin
  dmy:=0;
  sz:=GetFileVersionInfoSize(PChar(srcfile),dmy);
  IF sz=0 THEN BEGIN
    result:=GetLastError;
    Exit;
  END;
  try
    GetMem(pVerInfo,sz);
    try
      IF NOT GetFileVersionInfo(PChar(srcfile),0,sz,pVerInfo) THEN BEGIN
        result:=GetLastError;
      END ELSE BEGIN
        IF NOT VerQueryValue(pVerInfo,'\',pInfo,udmy) THEN BEGIN
          result:=GetLastError;
        END ELSE BEGIN
          WITH TVSFixedFileInfo(pInfo^) DO BEGIN
            // ver 1.20 rel 6 build 3 -> 0001 001A 0006 0003
            mjr:=(dwFileVersionMS AND $FFFF0000) SHR 16;
            mnr:=dwFileVersionMS AND $FFFF;
            rel:=(dwFileVersionLS AND $FFFF0000) SHR 16;
            bld:=dwFileVersionLS AND $FFFF;
            result:=0;
          END;
        END;
      END;
    finally
      FreeMem(pVerInfo);
    end;
  except
    ON EOutOfMemory DO
      result:=ERROR_NOT_ENOUGH_MEMORY;
  end;
end;


///////////////////////////////////////////////////////////////////////////
//
// Directory֘A̎葱E֐
//
///////////////////////////////////////////////////////////////////////////

// i:\work\level,0 -> i:\
//              ,1 -> i:\work
//              ,2 -> i:\work\level
// \\unc\name\work\level,0  -> \\unc\name
//                      ,1  -> \\unc\name\work
//                      ,2  -> \\unc\name\work\level
//                      ,-1 -> \\unc
function ExtractDirLevelU(const src:string; const Level:integer):string;
var
  idx,lvl : integer;
begin
  // ?:\xxx\yyy\..level 0ȂPɃRs[
  IF (Level=0) AND (NOT IsUNCPathU(src)) THEN BEGIN
    result:=copy(src,1,3); Exit;
  END;
  idx:=1; result:='';
  IF IsUNCPathU(src) THEN lvl:=-3 ELSE lvl:=0;
  WHILE idx<=Length(src) DO BEGIN
    IF src[idx]=YenU THEN BEGIN
      INC(lvl);
      IF lvl>Level THEN break;
    END;
    result:=result+src[idx];
    INC(idx);
  END;
end;

// Directory̑݃`FbN
// UNCɂΉ
function AyaDirectoryExistsSubU(const Name: String; TrueDir:boolean): Boolean;
var
  work : String;
  Code : Integer;
begin
  result:=false;
  IF name='' THEN Exit;
  work:=AyaExpandFilenameU(name,false);
  IF (work=NetRootU) THEN BEGIN
    if TrueDir then
      result:=false
    else
      result:=true;
    Exit;
  END;
  IF IsUNCPathU(work) AND (WideLastChar(work)^=YenU) THEN SetLength(work,length(work)-1);
  IF IsUNCServerU(work) OR IsUNCSharenameU(work) THEN BEGIN
    IF TrueDir THEN
      result:=false
    ELSE
      result:=IsUNCExistU(work,RESOURCETYPE_ANY)
  END ELSE BEGIN
    IF Length(work)=3 THEN BEGIN
      // root drivȅꍇ
      result:=CheckDriveExistsU(work[1]);
    END ELSE BEGIN
      // ̑
      Code := GetFileAttributesW(PWideChar(Name));
      Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
    END;
  END;
end;

function AyaDirectoryExistsU(const Name: String): Boolean;
begin
  result:=AyaDirectoryExistsSubU(Name,FALSE);
end;

function AyaTrueDirectoryExistsU(const Name: String): Boolean;
begin
  result:=AyaDirectoryExistsSubU(Name,TRUE);
end;

// removable device(or network)ǂ`FbN
function CheckRemovableU(trg:String):boolean;
var
  w : UINT;
begin
  w:=GetDriveTypeW(PWideChar(trg));
  result:=(w=DRIVE_CDROM) OR (w=DRIVE_REMOVABLE) OR (w=DRIVE_REMOTE);
end;

// ̊KwɓnăfBNg
{
procedure AyaForceDirectoriesW(dir:WideString);
begin
  WideForceDirectories(dir);
end;
}

// S~fBNgH
function CheckDustBoxU(const trg:String):boolean;
const
  RecycleD = ':\RECYCLED';
  RecycleR = ':\RECYCLER';     // for XP
  RecycleB = ':\RECYCLE.BIN';  // for VISTA
var
  workname : String;
begin
  // ܂VISTAS~`FbN
  IF length(trg)=14 THEN BEGIN
    workname:=AnsiUpperCase(Copy(trg,2,13));
    result:=(workname=RecycleB);
  END ELSE BEGIN
    workname:=AnsiUpperCase(Copy(trg,2,14));
    result:=(workname=(RecycleB+YenW));
  END;
  // VISTAS~Ȃ̂Ŏ̔
  IF NOT result THEN BEGIN
    IF length(trg)=11 THEN BEGIN   // x:\RECYCLE?p
      workname:=AnsiUpperCase(Copy(trg,2,10));
      result:=(workname=RECYCLED) OR (workname=RECYCLER);
    END ELSE BEGIN
      workname:=AnsiUpperCase(Copy(trg,2,11));
      result:=(workname=(RECYCLED+YenW)) OR (workname=(RECYCLER+YenW));
    END;
  END;
end;

// JgfBNgݒ
function SetCurrentDirU(adir:String):boolean;
begin
  result:=SetCurrentDirectoryW(PWideChar(adir));
end;

// JgfBNgϐݒ
function SetCurDrvToEnvU(curdir:String):DWORD;
var
  work : WideString;
begin
  work:=AnsiUpperCase(ExpandFilename(curdir));
  IF IsUNCPathU(curdir) THEN BEGIN
    result:=NO_ERROR; Exit;
  END;
  work:='='+work[1]+':';
  IF SetEnvironmentVariableW(PWideChar(work),PWideChar(curdir)) THEN
    result:=NO_ERROR
  ELSE
    result:=GetLastError;
end;

// JgfBNgݒ肵āAϐύX
function SetCurDirAndEnvU(dir:String):DWORD;
begin
  IF SetCurrentDirU(dir) THEN
    result:=SetCurDrvToEnvU(dir)
  ELSE
    result:=GetLastError;
end;

// JgfBNgϐNA
function ClearCurDrvFromEnvU(curdir:String):DWORD;
var
  work : String;
begin
  work:=AnsiUpperCase(ExpandFilename(curdir));
  IF IsUNCPathU(work) THEN BEGIN
    result:=NO_ERROR; Exit;
  END;
  work:='='+work[1]+':';
  IF SetEnvironmentVariableW(PWideChar(work),nil) THEN
    result:=NO_ERROR
  ELSE
    result:=GetLastError;
end;

function IsDirectoryU(const Name:String):boolean;
var
  work : string;
begin
  result:=false;
  IF name='' THEN Exit;
  work:=ExpandFilename(name);
  IF (work=NetRootU) THEN Exit;
  IF IsUNCPathU(work) AND (WideLastChar(work)^=YenW) THEN SetLength(work,length(work)-1);
  IF IsUNCServerU(work) THEN
    Exit
  ELSE IF IsUNCSharenameU(work) THEN
    result:=IsUNCExistU(work,RESOURCETYPE_ANY)
  ELSE IF IsUNCPathU(work) THEN
    result:=IsUNCExistU(ExtractDirLevelU(work,0),RESOURCETYPE_ANY)
  ELSE
    result:=CheckDriveExistsU(work[1]);
end;

// JgfBNg̎擾
function GetCurrentDirU:String;
var
  buf : array[0..MAX_PATH] of WideChar;
begin
  result:='';
  fillchar(buf[0],sizeof(buf),0);
  IF 0<>GetCurrentDirectoryW(MAX_PATH+1,@buf[0]) THEN result:=PWideChar(@buf[0]);
end;

// TufBNg
// ATrgDirABaseDir̃TufBNgȂΐ^
// SUBST΍Ă
function IsSubDirU(ABaseDir,ATrgDir:String):boolean;
var
  bd,td,work : String;
  bdlen,tdlen : integer;
begin
  result:=false;
  // SUBST΍
  bd:=ExpandUNCFilename(ExpandFilenameExU(ABaseDir));
  td:=ExpandUNCFilename(ExpandFilenameExU(ATrgDir));
  bdlen:=Length(bd); tdlen:=Length(td);
  IF bdlen<=tdlen THEN BEGIN
    work:=Copy(td,1,bdlen);
    result:=(AnsiCompareText(bd,work)=0) AND
            ( (bdlen=tdlen) OR (td[bdlen+1]='\') );
  END;
end;

/////////////////////////////////////////////////////////////////////////////
//
// UNC֘A
//
/////////////////////////////////////////////////////////////////////////////

// `IȖO̊mF̂
function IsUNCPathU(trg:String):boolean;
begin
  result:=false;
  IF Length(trg)<3 THEN Exit;
  result:=(NetRootU=copy(trg,1,2)) AND
          (YenW<>trg[3]) AND
          (NOT IsInvalidNameU(trg[3]));   // \\?\O
end;

// `IȖO̊mF̂
function IsUNCServerU(trg:string):boolean;
begin
  result:=false;
  IF trg='' THEN Exit;
  IF WideLastChar(trg)^=YenW THEN trg:=copy(trg,1,length(trg)-1);
  IF Length(trg)<3 THEN Exit;   // ȂƂ\\a
  result:=(NetRootU=copy(trg,1,2)) AND
          (CountYenU(trg)=2) AND
          (NOT IsInvalidNameU(trg[3]));
end;

// `IȖO̊mF̂
function IsUNCShareNameU(trg:string):boolean;
begin
  result:=false;
  IF trg='' THEN Exit;
  IF WideLastChar(trg)^=YenW THEN trg:=copy(trg,1,length(trg)-1);
  IF Length(trg)<5 THEN Exit;  // ȂƂ\\a\b
  result:=(NetRootU=copy(trg,1,2)) AND
          (CountYenU(trg)=3) AND
          (NOT IsInvalidNameU(trg[3]));
end;

function IsUNCExistU(trg:string; dwType:DWORD):boolean;
var
  dmy:string;
  function IsUNCSrvExistU:boolean;
  var
    w : TStringList;
    i : integer;
  begin
    w:=GetServerNameList(false);
    try
      result:=w.Find(trg,i);
    finally
      w.free;
    end;
  end;
begin
  result:=false;
  if GetBelongDomainName='' then exit; // Domain/WorkgroupɎQĂȂ
  IF trg=NetRootU THEN
    result:=TRUE
  ELSE IF IsUNCServerU(trg) THEN
    result:=IsUNCSrvExistU
  ELSE
    result:=GetUNCNameU(trg,dwType,dmy);
end;

///////////////////////////////////////////////////////////////////////////
//
// network֘A
//
//////////////////////////////////////////////////////////////////////////

function GetMyMachineName:string; // @̃}V
var
  pWi : PWKSTA_INFO_100;
begin
  result:='';
  pWi:=nil;
  try
    if NetWkstaGetInfo(nil,100,@pWi)=NO_ERROR then
      result:=pWi^.wki100_computername;
  finally
    if pWi<>nil then NetApiBufferFree(pWi);
  end;
end;

function GetBelongDomainName(AName:string):string;
var
  pWi : PWKSTA_INFO_100;
  pName : PWideChar;
  sts : DWORD;
begin
  result:='';
  if AName='' then
    pName:=nil
  else
    pName:=@AName[1];
  pWi:=nil;
  try
    sts:=NetWkstaGetInfo(pName,100,@pWi);
    if sts=NO_ERROR then
      result:=pWi^.wki100_langroup;
  finally
    if pWi<>nil then NetApiBufferFree(pWi);
  end;
end;

function GetBelongDomainName:string;   // @workgroup or domain
begin
  result:=GetBelongDomainName('');
end;

function NeedPasswdU(trgunc:String):TPasswdType;
  function CheckSrv(trg:String):DWORD;
  var
    nr : TNetResourceW;
    sts : DWORD;
    h : THandle;
  begin
    FillChar(nr,sizeof(nr),0);
    WITH nr DO BEGIN
      dwScope:=RESOURCE_GLOBALNET;
      dwType:=RESOURCETYPE_ANY;
      dwDisplayType:=RESOURCEDISPLAYTYPE_SERVER;
      dwUsage:=RESOURCEUSAGE_CONTAINER;
      lpRemoteName:=PWideChar(trg);
    END;
    sts:=WNetOpenEnumW(RESOURCE_GLOBALNET,RESOURCETYPE_ANY,0,@nr,h);
    IF sts=NO_ERROR THEN WNetCloseEnum(h);
    result:=sts;
  end;
var
  sv,sts : integer;
  sn,srv : string;
  sr : TSearchRec;
begin
  result:=npwNONE; // default͂Ȃ
  IF NOT IsUNCPathU(trgunc) THEN Exit; // UNCŖfalse
  IF trgunc=NetRootU THEN Exit;           // topȂfalse
  // SERVER LEVELŃ`FbN
  srv:=ExtractDirLevelU(trgunc,-1);
  IF ERROR_NOT_AUTHENTICATED=CheckSrv(srv) THEN BEGIN
    result:=npwSERVER;
    Exit;
  END;
  // SHARENAME LEVELŃ`FbN
  sn:=ExtractDirLevelU(trgunc,0);
  sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
  try
    sts:=FindFirst(sn+'\*.*',faAnyFile-faVolumeID,sr);
    IF sts=0 THEN
      FindClose(sr)
    ELSE BEGIN
      IF sts=ERROR_INVALID_PASSWORD THEN result:=npwSHARE;
    END;
  finally
    SetErrorMode(sv);
  end;
end;

function GetNetworkErrorU(var ErrCode:DWORD; var ErrMsg,Provider:string):boolean;
const
  MsgSize=256;
var
  PMsg,Prv : array[0..MsgSize] of WideChar;
begin
  FillChar( Pmsg[0], sizeof(PMsg), 0 );
  FillChar( Prv[0], sizeof(Prv), 0 );
  IF NO_ERROR=WNetGetLastErrorW(ErrCode,@PMsg[0],MsgSize,@Prv[0],MsgSize) THEN BEGIN
    result:=true;
    PMsg[MsgSize]:=#0; Prv[MsgSize]:=#0;
    ErrMsg:=PMsg; Provider:=Prv;
  END ELSE
    result:=false;
end;


function GetUNCNameU(trg:string; dwType:DWORD; var rightstr:string):boolean;
var
  src : string;
  nro : TNetResourceObjU;
begin
  result:=false; rightstr:='';
  src:=ExpandFilename(trg);
  IF (src='') THEN Exit;
  IF (src<>NetRootU) AND (WideLastChar(src)^=YenW) THEN SetLength(src,Length(src)-1);
  IF NOT IsUNCPathU(src) THEN Exit;
  nro:=FindAndDupUNCObj(trg);
  if nro<>nil then begin
    try
      CASE dwType OF
        RESOURCETYPE_DISK:
          IF (nrrDISK in nro.ResTypes) AND
             (0=AnsiCompareText(nro.Remotename,src)) THEN BEGIN
            result:=true; rightstr:=nro.Remotename;
          END;
        RESOURCETYPE_PRINT:
          IF (nrrPRINT in nro.ResTypes) AND
             (0=AnsiCompareText(nro.Remotename,src)) THEN BEGIN
            result:=true; rightstr:=nro.Remotename;
          END;
        RESOURCETYPE_RESERVED:
          IF (nrrRESERVED in nro.ResTypes) AND
             (0=AnsiCompareText(nro.Remotename,src)) THEN BEGIN
            result:=true; rightstr:=nro.Remotename;
          END;
        ELSE
          IF (0=AnsiCompareText(nro.Remotename,src)) THEN BEGIN
            result:=true; rightstr:=nro.Remotename;
          END;
      END;
    finally
      nro.Free;
    end;
  end;
end;

//////////////////////////////////////////////////////////////////////////////
//
// ̑
//
//////////////////////////////////////////////////////////////////////////////

// \JEg - UnicodeƊyX...
function CountYenU(srcname:string):integer;
var
  i : integer;
begin
  result:=0;
  FOR i:=1 TO Length(srcname) DO
    IF srcname[i]=YenW THEN Inc(result);
end;

// 󔒂LȂ''ň͂
function AddDoubleQuatU(const trgname:string):string;
begin
  IF Pos(SpcU,trgname)>0 THEN // PosWideStringT|[gĂ
    result:=DQuatU+trgname+DQuatU
  ELSE
    result:=trgname;
end;

//
function GetDropFilesU(var msg:TWmDropFiles):TStringList;
var
  cnt,i,sv,sz : integer;
  buf : PWideChar;
  filename : String;
  sr : TSearchRec;
begin
  result:=nil;
  cnt:=DragQueryFileW(msg.drop,Cardinal(-1),NIL,0);
  IF cnt>0 THEN BEGIN
    result:=TStringList.Create;
    sv:=SetErrorMode(SEM_FAILCRITICALERRORS);
    try
      FOR i:=0 TO cnt-1 DO BEGIN
        sz:=DragQueryFileW(msg.Drop,i,nil,0);
        IF sz>0 THEN BEGIN
          try
            GetMem(buf,(sz+1)*sizeof(WideChar));
            try
              FillChar(buf^,(sz+1)*sizeof(WideChar),0);
              DragQueryFileW(msg.drop,i,buf,sz+1);
              filename:=String(buf);
              IF FindFirst(Filename,faAnyFile-faVolumeID,sr)=0 THEN BEGIN
                filename:=ExpandFilename(filename);
                FindClose(sr);
              END;
              result.Add(filename);
            finally
              FreeMem(buf);
            end;
          except
            ON EOutOfMemory DO ;
          end;
        END;
      END;
    finally
      SetErrorMode(sv);
    end;
  END;
  Msg.Result:=0;
  DragFinish(Msg.Drop);
end;

function GetVolumeNameForVolumeMountPoint; external 'kernel32.dll' name 'GetVolumeNameForVolumeMountPointW';

//////////////////////////////////////////////////////////////////////////////
//
// jbg̏
//
//////////////////////////////////////////////////////////////////////////////
procedure Init;
begin
  //FMyDomain:=nil;
  DT2Sec:=StrToDateTime('00:00:02');
end;


//////////////////////////////////////////////////////////////////////////////
//
// jbg̏I
//
//////////////////////////////////////////////////////////////////////////////
procedure Done;
begin
  //if Assigned(FMyDomain) then FreeAndNil(FMyDomain);
end;

initialization
  Init;

finalization
  Done;

end.
