unit browseflw;

//////////////////////////////////////////////////////////////////////////////
//
// PSHBrowseForFolderW̃bp[NX
//
// Copyright (C) 2004-2008 Ayakawa,Marinosuke & MarleySoft
//
// http://homepage1.nifty.com/Ayakawa/
//
// gpEǁE]ځEzz
//@ ̃jbgɂāAgpE]ځEzz͂RɂȂĂB
// @łA]ځEzzƂ̓A[JCu̍\͕ςȂłˁB
//   OE̘A͂܂B
//   ǂ̂ARɎgpEzzE]ڂĂiĂ邩
//   ǂ͉ǂl̈ӎvłjBÃjbgɂĂ
//   E`͈ɂ́uvƂ͖LĂĂB
//
// 񑩂
// @̃jbgA͉ρEǂꂽjbg̎gpɂAȂ炩
//   ̔QĂҁ@fTisہ@j́AؐӔC𕉂
//   B
//
// rev  0.00
// date 2004/03/02
// auth Ayakawa,Marinosuke
// memo 
//
// rev  0.01
// date 2004/03/05
// auth Ayakawa,Marinosuke
// memo ayashellwւ̈ˑBTntR|Ăg悤
//      Ȃ܂B
//
// rev  0.02
// date 2008/10/25
// auth Ayakawa,Marinosuke
// memo Delphi 2009pporting
//
//////////////////////////////////////////////////////////////////////////////

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TBrowseFolderW = class(TComponent)
  private
    { Private 錾 }
    FDir, FDefaultDir, FTitle: String;
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner:TComponent); override;
    Function Execute: Boolean;
    property DefaultDir : string read FDefaultDir write FDefaultDir;
    Property DirName: String Read FDir;
  published
    { Published 錾 }
    Property Title: String Read FTitle Write FTitle;
  end;

procedure Register;

implementation

Uses
  ShlObj,activex,ayashellu;

procedure Register;
begin
  RegisterComponents('AyaCompos', [TBrowseFolderW]);
end;

function BrowseCallbackProc(hW: HWND; iM: UINT; fP: LPARAM;  fD: LPARAM)
        : Integer; stdcall;
var
  pidl : PItemIDList;
begin
    if (iM = BFFM_INITIALIZED) then BEGIN
      pidl:=PIDListFromPathU(string(PWideChar(fD)));
      IF pidl<>nil THEN BEGIN
        // pathUnicodeˑ̕LꍇItemIDListgȂ
        // tH[JXȂI
        SendMessageW(hW, BFFM_SETSELECTION, 0, LPARAM(pidl));
        CoTaskMemFree(pidl);
      END ELSE
        SendMessageW(hW, BFFM_SETSELECTION, 1, fD);
    END;
    Result := 0;
end;

constructor TBrowseFolderW.Create(AOwner:TComponent);
begin
  inherited;
  FDefaultDir:=''; FDir:=''; FTitle:='';
end;

Function TBrowseFolderW.Execute;
var
  BI: TBrowseInfoW;
  IDList: PItemIDList;
  Dir: Array [0..Max_Path] Of WideChar;
begin
  FDir := '';
  Result := False;
  FillChar(BI, SizeOf(BI), 0);
  BI.hwndOwner := TWinControl(Owner).Handle;
  //BI.lpfn := nil;
  BI.lpfn := Pointer(@BrowseCallbackProc);
  BI.lpszTitle := PWideChar(FTitle);
  BI.pidlRoot := nil;
  BI.ulFlags := BIF_RETURNONLYFSDIRS + BIF_STATUSTEXT;
  IF DefaultDir<>'' THEN BI.lParam:=Windows.LPARAM(PWideChar(DefaultDir));
  IDList := SHBrowseForFolderW(BI);
  If IDList <> nil Then
  Begin
    SHGetPathFromIDListW(IDList, Dir);
    CoTaskMemFree(IDList);
    FDir := WideString(Dir);
    Result := True;
  End;
end;

end.
