unit savef;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, browseflw;

type
  TSaveForm = class(TForm)
    Bevel1: TBevel;
    ADSNameLB: TLabel;
    Bevel2: TBevel;
    NameEd: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    FolderEd: TEdit;
    FolderBtn: TButton;
    SaveBtn: TButton;
    CancelBtn: TButton;
    BrowseFolderW: TBrowseFolderW;
    procedure NameEdKeyPress(Sender: TObject; var Key: Char);
    procedure FolderBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    function SaveDlg(AnADSName:string; var ASaveName:string):boolean;
  end;

  function SaveDlg(AOwner:TComponent; AnADSName:string; var ASaveName:string):boolean;


implementation

{$R *.dfm}

uses
  ayafutilu;

function SaveDlg(AOwner:TComponent; AnADSName:string; var ASaveName:string):boolean;
var
  fm : TSaveForm;
begin
  fm:=TSaveForm.Create(AOwner);
  try
    result:=fm.SaveDlg(AnADSName,ASaveName);
  finally
    fm.free;
  end;
end;

function TSaveForm.SaveDlg(AnADSName:string; var ASaveName:string):boolean;
var
  i : integer;
  w : string;
begin
  ADSNameLB.Caption:=AnADSName;
  w:='';
  AnADSName:=StringReplace(AnADSName,':$DATA','',[]);
  AnADSName:=StringReplace(AnADSName,':','.',[]);
  for I := 1 to Length(AnADSName) do
    if NOT IsInvalidNameU(AnADSName[i]) then w:=w+AnADSName[i];
  NameEd.Text:=w;
  FolderEd.Text:=GetCurrentDir;
  result:=mrOK=ShowModal;
  if result then
    ASaveName:=FolderEd.Text+'\'+NameEd.Text;
end;

procedure TSaveForm.FolderBtnClick(Sender: TObject);
begin
  BrowseFolderW.DefaultDir:=FolderEd.Text;
  if BrowseFolderW.Execute then
    FolderEd.Text:=BrowseFolderW.DirName;
end;

procedure TSaveForm.NameEdKeyPress(Sender: TObject; var Key: Char);
begin
  if IsInvalidNameU(Key) then Key:=#0;
end;


end.
